



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>python 之编码问题详解</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">python 之编码问题详解</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-01-28 18:03:42 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>前在一个项目中遇到用post提交一个xml，xml中含有中文，对于单独的py文件，使用urllib2.urlopen完全ok，但在django中使用就一直报编码错误，然后在网上看到这篇文章不错，决定mark一下，学习学习。原文地址：<a href="http://www.2cto.com/kf/201407/317866.html" rel="external nofollow noreferrer">http://www.2cto.com/kf/201407/317866.html</a></p>
<p>全部是在python2.7.*的环境下。</p>
<h2>1.Python编码基础</h2>
<h3>1.1 str和unicode</h3>
<p>python中有两种数据模型来支持字符串这种数据类型，str和unicode，它们的基类都是basestring。比如<code>s = "中文"</code>就是str类型的字符串，而<code>u=u"中文"</code>就是一个unicode类型的字符串。unicode是由str类型的字符串解码后得到，unicode也可以编码成str类型。即</p>
<div>
<div><code>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; str --&gt; decode --&gt; unicode</code></div>
<div><code>unicode --&gt; encode --&gt; str</code></div>
<div>&nbsp;</div>
<div><code>严格来说，str也许应该叫做字节串，因为对于UTF-</code><code>8</code><code>编码的str类型</code><code>"中文"</code><code>，使用len()<code>函数得到的结果是</code><code>6</code><code>，因为UTF-</code><code>8</code><code>编码的str类型&ldquo;中文&rdquo;<code>实际是</code><code>"\xe4\xb8\xad\xe6\x96\x87"</code><code>。而<code>对于unicode类型u&ldquo;中文&rdquo;(实际是u</code><code>"\u4e2d\u6587"</code><code>)，使用len()函数得到结果是</code><code>2。</code></code></code></code></div>
<div>
<h3>1.2 头部编码声明</h3>
<p>在python源代码文件中如果有用到非ascii字符，比如中文，那么需要在源码文件头部声明源代码字符编码，格式如下：</p>
<div>
<pre class="prettyprint linenums"> #-*- coding: utf-8 -*-</pre>
</div>
<p><code>这个格式看起比较复杂，其实python只检查#、coding，编码等字符串，可以简写成#co</code><code>ding:utf-</code><code>8</code><code>，甚至还可以写成#coding:u8。</code></p>
<h2>2.Python2.x常见编码问题</h2>
<h3>2.1 头部编码声明和文件编码问题</h3>
<p>文件头部编码声明决定了python解析源码中的str的编码选择方式，比如头部声明的是utf-8编码，则代码中<code>s="中文"</code>python就会按照utf-8编码格式来解析，通过<code>repr(s)</code>可以看到字符编码是<code>"\xe4\xb8\xad\xe6\x96\x87"</code>，如果头部声明的编码是gbk编码，则python会对s采用gbk编码解析，结果是<code>"\xd6\xd0\xce\xc4"</code>。</p>
<p>需要注意的是，文件本身的编码要跟文件头部声明编码一致，不然就会出现问题。文件本身的编码在Linux下面可以在vim下用命令<strong><code>set fenc</code></strong>来查看。如果文件本身编码是gbk，而源码文件头部声明的编码是utf-8，这样如果源码中有中文就会有问题了，因为本身中文str存储是按照gbk编码来的，而python在解析str的时候又以为是utf-8编码，这样就会报<code>SyntaxError: (unicode error) 'utf8' codec can't decode byte</code>错误。</p>
<h3>2.2 默认编码问题</h3>
<p>下面看个python默认编码导致的问题：</p>
<div>
<pre class="prettyprint linenums"> #coding: utf-8<br />
 u = u"中文"<br />
 print repr(u) # u'\u4e2d\u6587'

 s = "中文"<br />
 print repr(s) # '\xe4\xb8\xad\xe6\x96\x87'

 u2 = s.decode("utf-8")<br />
 print repr(u2) # u'\u4e2d\u6587'

 #s2 = u.decode("utf-8") #编码错误<br />
 #u2 = s.encode("utf-8") #解码错误</pre>
</div>
<p><code>注意实例中注释掉的</code><code>2</code><code>行代码，对于unicode最好不要直接调用decode，str最好不要直接调</code><code>用encode方法。因为如果是直接调用，则相当于</code></p>
<div>
<pre class="prettyprint linenums"> u.encode(default_encoding).decode("utf-8")    # default_encoding是python的unicode实现中用的默认编码，即 sys.getdefaultencoding() 得到的编码</pre>
</div>
<p><code>如果你没有设置过，那么默认编码就是ascii，如果你的unicode本身超出了ascii编码范围就会报错。同理，如果对str直接调用encode方法，那么默认会先对str进行解码，即</code></p>
<div>
<pre class="prettyprint linenums"> s.decode(default_encoding).encode("utf-8")</pre>
</div>
<p><code>如果str本身是中文，而default_encoding是ascii的话，解码就会出错，从而导致上面这两行会分别报</code></p>
<div>
<pre class="prettyprint linenums">UnicodeEncodeError: 'ascii' codec can't encode characters in position...</pre>
</div>
<p>和</p>
<div>
<pre class="prettyprint linenums">UnicodeDecodeError: 'ascii' codec can't decode byte 0xe4 in position...</pre>
</div>
<p>上面例子中注释掉的两行代码如果执行就会报错，当然，如果本身str或者unicode都在ascii编码范围，就没有问题。比如<code>s = "abc"; s.encode("utf-8")</code>就不会有问题，语句执行后会返回一个跟s的id不同的str。</p>
<p>那如果要解决实例1中的问题，有两种方法，其一是明确指定编码，如下所示:</p>
<div>
<pre class="prettyprint linenums"> #coding: utf-8<br />
 u = u"中文"<br />
 print repr(u) # u'\u4e2d\u6587'

 s = "中文"<br />
 print repr(s) # '\xe4\xb8\xad\xe6\x96\x87'

 u2 = s.decode("utf-8")<br />
 print repr(u2) # u'\u4e2d\u6587'

 s2 = u.encode("utf-8").decode("utf-8")  # OK<br />
 u2 = s.decode("utf8").encode("utf-8")   # OK</pre>
</div>
<p><code>第二种方法就是更改python的默认编码为文件编码格式，如下所示(这里只所以要reload <code>sys模块，是因为python初始化后删除了setdefaultencoding方法：</code><br /></code></p>
<div>
<pre class="prettyprint linenums"> #coding:utf-8                                                                  

 import sys<br />
 reload(sys)<br />
 sys.setdefaultencoding("utf-8") #更改默认编码为utf-8

 u = u"中文"<br />
 print repr(u) # u'\u4e2d\u6587'

 s = "中文"<br />
 print repr(s) # '\xe4\xb8\xad\xe6\x96\x87'

 u2 = s.decode("utf-8")<br />
 print repr(u2) # u'\u4e2d\u6587'

 s2 = u.decode("utf-8")<br />
 u2 = s.encode("utf-8")</pre>
</div>
<h3>2.3读写文件编码</h3>
<p>采用python的open()方法打开文件时，read()读取的是str，编码就是文件本身的编码。而调用write()写文件时，如果参数是 unicode，则需要用指定编码encode，如果write()参数是unicode而且没有指定编码，则会采用python默认编码(sys.getdefaultencoding())encode后再写入。</p>
<div>
<pre class="prettyprint linenums"> #coding:utf-8<br />
 f = open("testfile")<br />
 s = f.read()<br />
 f.close()<br />
 print type(s) # &lt;type str&gt;

 u = s.decode("utf-8") #testfile是utf-8编码<br />
 f = open("testfile", "w")<br />
 f.write(u.encode("gbk")) #以gbk编码写入，testfile为gbk编码<br />
 f.close()</pre>
</div>
<p>此外，python的codecs模块提供了一个open()方法，可以指定编码打开文件，使用这个方法打开文件读取返回是unicode。写入时，如果 write参数是unicode，则使用打开文件时的编码写入，如果是str，则先使用默认编码解码成unicode后再以打开文件的编码写入(这里需要 注意如果str是中文，而默认编码sys.getdefaultencoding()是ascii的话会报解码错误)。</p>
<div>
<pre class="prettyprint linenums">#coding:gbk<br />
import codecs

f = codecs.open('testfile', encoding='utf-8')<br />
u = f.read()<br />
f.close()<br />
print type(u) # &lt;type unicode&gt;

f = codecs.open('testfile', 'a', encoding='utf-8')<br />
f.write(u) #写入unicode

# 写入gbk编码的str，自动进行解码编码操作<br />
s = '汉'<br />
print repr(s) # '\xba\xba'<br />
# 这里会先将GBK编码的str解码为unicode再编码为UTF-8写入<br />
#f.write(s) #默认编码为ascii时，这会报解码错误。<br />
f.close()</pre>
</div>
<h2>3. 关于BOM头</h2>
<p>有些软件在保存UTF-8编码的时候，会在文件最开始的地方插入不可见的字符BOM（0xEF 0xBB 0xBF，即BOM），这些不可见字符无法被识别，encode的时候会报错，例如：（utf-8转为gbk）</p>
<div>
<pre class="prettyprint linenums">UnicodeEncodeError:'gbk' codec can't encode character u'\ufeff' in position 0: illegal multibyte sequence</pre>
</div>
<p>遇到这种情况可以利用codecs模块：（test.txt以utf-8保存）</p>
<div>
<pre class="prettyprint linenums"> import codecs<br />
 content = open('test.txt', 'r').read()<br />
 filehandle.close()<br />
 if content[:3] == codecs.BOM_UTF8:    # 如果存在BOM头则去掉<br />
     content = content[3:]

 print content.decode('utf-8').encode('gbk')</pre>
</div>
</div>
</div>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/xq47k0qz.html">ucos实时操作系统学习笔记&mdash;&mdash;操作系统在STM32的移植</a>
		</li>
						<li><a href="https://www.batexi.com/a/4qnw7xjq.html">Monkeyrunner小脚本关于camera的使用</a>
		</li>
						<li><a href="https://www.batexi.com/a/m96le2v9.html">如何在JavaScript中正确引用某个方法&lpar;bind方法的应用&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/m8zllz1q.html">js获取鼠标位置的各种方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/49gydm09.html">【iCore3 双核心板&lowbar;FPGA】例程二：GPIO输出实验&mdash;&mdash;点亮三色LED</a>
		</li>
						<li><a href="https://www.batexi.com/a/m8z74l19.html">PHP- 数字转汉字</a>
		</li>
						<li><a href="https://www.batexi.com/a/xq4oevn8.html">Python爬虫 -- 抓取电影天堂8分以上电影</a>
		</li>
						<li><a href="https://www.batexi.com/a/3906v039.html">价值100W的经验分享&colon; 基于JSPatch的iOS应用线上Bug的即时修复方案&comma;附源码&period;</a>
		</li>
						<li><a href="https://www.batexi.com/a/jqdm6mvq.html">全面解析Linux数字文件权限</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwd5d1l8.html">linux 命令部分说明</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j0p40lq.html">&lpar;转&rpar;Linux概念架构的理解</a>
		</li>
						<li><a href="https://www.batexi.com/a/8e135px9.html">Networking - IPv4 报文格式</a>
		</li>
						<li><a href="https://www.batexi.com/a/93xz04z9.html">zoj3640：概率（期望）dp</a>
		</li>
						<li><a href="https://www.batexi.com/a/93x0yjn9.html">转载文章：Windows Azure 七月份更新：SQL 数据库、流量管理器、自动伸缩、虚拟机</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwjkk138.html">编译最新ffmpeg2&period;0&period;1到iOS设备</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwvj74y8.html">tomcat与iis公用80端口（已经发布&period;net项目现在开发Java项目时tomcat在eclipse中localhost：8080打不开问题）</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7oejne8.html">js中图片上传&comma;多次上传同一张不生效</a>
		</li>
						<li><a href="https://www.batexi.com/a/q25g0g3q.html">Python随笔--函数&lpar;参数&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwvyr5z8.html">跳石头&vert;河中跳房子&vert;NOIP2015提高组T4&vert;二分法</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnno0lgq.html">1085&period; &lbrack;SCOI2005&rsqb;骑士精神【IDA※】</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/q7mox4eq.html">【转】VS2012程序打包部署详解</a>
			</li>
						<li><a href="https://www.batexi.com/a/95xg0me8.html">centos6&period;5 安装iptables</a>
			</li>
						<li><a href="https://www.batexi.com/a/qydyy4gq.html">Hibernate常用配置文件详解</a>
			</li>
						<li><a href="https://www.batexi.com/a/qlmlow19.html">ARM汇编常用指令</a>
			</li>
						<li><a href="https://www.batexi.com/a/9gmj4je9.html">FFTW简介及使用</a>
			</li>
						<li><a href="https://www.batexi.com/a/8k1jnvj9.html">MySQL时间戳和时间格式转换函数</a>
			</li>
						<li><a href="https://www.batexi.com/a/95xgjy68.html">insmod module&lowbar;param 模块参数</a>
			</li>
						<li><a href="https://www.batexi.com/a/9pjw3ez9.html">我的Android最佳实践之&mdash;&mdash; 解决闪空界面问题</a>
			</li>
						<li><a href="https://www.batexi.com/a/qn1vy3g8.html">黄聪：get&lowbar;posts 函数 &vert; wordpress</a>
			</li>
						<li><a href="https://www.batexi.com/a/8z1y3lx9.html">jQuery Ajax 方法调用 Asp&period;Net WebService 以及调用aspx&period;cs中方法的详细例子</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
